<!DOCTYPE html>
<html lang="fr">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Politweets</title>
    <link href='https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900|Material+Icons' rel="stylesheet">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css"
        integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
    <link href="https://cdn.jsdelivr.net/npm/vuetify/dist/vuetify.min.css" rel="stylesheet">
</head>

<body>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.18.0/axios.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.9/dist/vue.min.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>
    <script src="https://unpkg.com/vuex"></script>
    <script src="https://cdn.jsdelivr.net/npm/vuetify/dist/vuetify.js"></script>

    <style>
        .twitter-accounts-list {
            margin-top: 25px;
        }

        .twitter-accounts-list .v-card {
            margin-bottom: 15px;
            cursor: pointer;
        }

        .twitter-accounts-list .v-card:hover {
            background-color: rgba(25, 118, 210, 0.6);
        }

        #no-account-message {
            width: -moz-fit-content;
            width: fit-content;
            margin: 10px auto 5px auto;
        }

        [v-cloak] {display: none}
    </style>

    <div id="app">
        <v-app v-cloak>
            <nav>
                <v-toolbar flat class="primary" app>
                    <v-toolbar-side-icon @click="appMenu = !appMenu" class="white--text"></v-toolbar-side-icon>
                    <v-toolbar-title class="white--text">Politweets</v-toolbar-title>
                    <v-spacer></v-spacer>
                    <v-toolbar-items>
                            <!-- Non connecté -->
                        <v-btn v-if="user == null" flat class="white--text" @click="loginDialog = true" >Connexion</v-btn>
                        <v-btn v-if="user == null" flat class="white--text" @click="registerDialog = true">Inscription</v-btn>
        
                        <v-menu offset-y v-if="user != null">
                            <!-- Connecté -->
                            <template v-slot:activator="{ on }">
                                <v-chip v-on="on" style="height: 32px; align-self: center;">
                                    <v-avatar>
                                        <img v-bind:src="user.avatar" alt="profile-picture">
                                    </v-avatar>
                                    {{user.name}}
                                    <v-icon style="margin-left: 5px;">fas fa-caret-down</v-icon>
                                </v-chip>
                            </template>
                            <v-list>
                                <v-list-tile @click="profileDialog = true">
                                    <v-list-tile-title>
                                        <v-icon style="margin-right: 5px; width: 24px;">far fa-user</v-icon>Profile
                                    </v-list-tile-title>
                                </v-list-tile>
                                <v-list-tile @click="logout()">
                                    <v-list-tile-title>
                                        <v-icon style="margin-right: 5px;">fas fa-sign-out-alt</v-icon>Se déconnecter
                                    </v-list-tile-title>
                                </v-list-tile>
                            </v-list>
                        </v-menu>
                        <v-btn color="white" fab small dark slot="activator" @click="globalSettingsDialog = true">
                            <v-icon color="primary">fas fa-cog</v-icon>
                        </v-btn>
                    </v-toolbar-items>
                </v-toolbar>

                <v-divider></v-divider>

                <v-navigation-drawer app v-model="appMenu">
                    <v-list dense class="pt-0">
                        <v-list-tile v-for="item in menuItems" :key="item.title" @click="navTo(item.route)">
                            <v-list-tile-action>
                                <v-icon>{{ item.icon }}</v-icon>
                            </v-list-tile-action>

                            <v-list-tile-content>
                                <v-list-tile-title style="font-family: Arial, Helvetica, sans-serif;">{{ item.title }}
                                </v-list-tile-title>
                            </v-list-tile-content>
                        </v-list-tile>
                    </v-list>
                    <div style="display: flex; flex-direction: row; align-items: center;">
                        <v-tooltip right>
                            <v-btn style="height: 30px; width: 30px;" color="primary" fab small dark slot="activator"
                                @click="searchSettingsDialog = true">
                                <v-icon>fas fa-cog</v-icon>
                            </v-btn>
                            <span>Paramètres de la recherche</span>
                        </v-tooltip>
                        <v-text-field v-model="query" v-on:keyup.enter="search(query)" style="margin: 0 10px;"
                            label="Recherche de tweets" append-icon="search" clearable app></v-text-field>
                    </div>
                    <div class="twitter-accounts-list" v-for="(twitterAccount, index) in twitterAccounts">
                        <v-card :color="twitterAccount.active? 'primary':''"
                            :class="twitterAccount.active? 'white--text':''" @click="selectTwitterAccount(index)">
                            <v-layout>
                                <v-flex xs5>
                                    <v-avatar size="70" style="margin: 6px 0 0 20px;">
                                        <img v-bind:src="twitterAccount.image" height="100px" contain>
                                    </v-avatar>
                                </v-flex>
                                <v-flex xs7>
                                    <v-card-title primary-title>
                                        <div>
                                            <div>{{twitterAccount.name}}</div>
                                            <div>{{twitterAccount.twitterRef}}</div>
                                        </div>
                                    </v-card-title>
                                </v-flex>
                            </v-layout>
                        </v-card>
                    </div>
                    <v-progress-circular v-if="loadingAccounts" indeterminate color="primary" :size="40" :width="7"
                        style="display: block !important; margin-left: auto; margin-right: auto;"></v-progress-circular>
                    <br>
                    <p v-if="twitterAccounts.length == 0 && !loadingAccounts && user" id="no-account-message">Aucun compte
                        twitter sauvegardé</p>
                    <v-tooltip right>
                        <v-btn v-if="user" small fab color="primary" @click="addPoliticianDialog=true" slot="activator">
                            <v-icon>fas fa-plus</v-icon>
                        </v-btn>
                        <span>Ajouter un compte twitter</span>
                    </v-tooltip>
                </v-navigation-drawer>
            </nav>

            <v-content>
                <v-container fluid>
                    <router-view></router-view>
                    <div class="text-xs-center" style="position: fixed; left: calc(50% - 100px); top: calc(50%);">
                        <v-progress-circular v-if="loading" indeterminate color="primary" :size="100" :width="7">
                        </v-progress-circular>
                    </div>
                </v-container>
            </v-content>

            <v-dialog v-model="searchSettingsDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Paramètres de la recherche</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-checkbox v-model="searchSettings.frOnly" label="Tweets en français seulement">
                                </v-checkbox>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="searchSettingsDialog = false">Fermer</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-dialog v-model="globalSettingsDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Paramètres généraux</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-checkbox v-model="globalSettings.darkTheme" label="Thème sombre"></v-checkbox>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="globalSettingsDialog = false">Fermer</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-dialog v-model="loginDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Connexion <v-progress-circular
                                style="margin-left: 10px;" v-if="dialogLoading" indeterminate :size="40" :width="7">
                            </v-progress-circular></span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-flex xs12>
                                    <v-text-field v-model="loginForm.user" prepend-icon="fas fa-user"
                                        label="Utilisateur" required></v-text-field>
                                </v-flex>
                                <v-flex xs12>
                                    <v-text-field v-model="loginForm.password" prepend-icon="fas fa-key"
                                        label="Mot de passe" type="password" required></v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="loginDialog = false">Fermer</v-btn>
                        <v-btn color="blue darken-1" flat @click="login(loginForm.user, loginForm.password)">Se
                            connecter</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-dialog v-model="registerDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Inscription <v-progress-circular
                                style="margin-left: 10px;" v-if="dialogLoading" indeterminate :size="40" :width="7">
                            </v-progress-circular></span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-flex xs12>
                                    <v-text-field v-model="registerForm.name" prepend-icon="fas fa-id-card" label="Nom"
                                        hint="Nom affiché sur votre profil" required></v-text-field>
                                </v-flex>
                                <v-flex xs12>
                                    <v-text-field v-model="registerForm.twitterUser" prepend-icon="fab fa-twitter"
                                        label="Nom d'utilisateur Twitter"
                                        hint="Lier votre compte Twitter à votre compte Politweets"></v-text-field>
                                </v-flex>
                                <v-flex xs12>
                                    <v-text-field v-model="registerForm.user" prepend-icon="fas fa-user"
                                        label="Utilisateur" hint="Utilisé pour vous connecter" required></v-text-field>
                                </v-flex>
                                <v-flex xs12>
                                    <v-text-field v-model="registerForm.password" prepend-icon="fas fa-key"
                                        label="Mot de passe" type="password" required>
                                    </v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="registerDialog = false">Fermer</v-btn>
                        <v-btn color="blue darken-1" flat
                            @click="register(registerForm.name, registerForm.twitterUser, registerForm.user, registerForm.password)">
                            Créer mon compte</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-dialog v-model="profileDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Profile</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-btn color="primary" @click="showSavedTweets()">Tweets sauvegardés</v-btn>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="profileDialog = false">Fermer</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-dialog v-model="mapDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Localisation</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-progress-circular style="position: absolute;" v-if="mapLoading" indeterminate
                                    :size="40" :width="7"></v-progress-circular>
                                <iframe width="425" height="350" frameborder="0" scrolling="no" marginheight="0"
                                    marginwidth="0"
                                    v-bind:src="'https://www.openstreetmap.org/export/embed.html?layer=mapnik'+getCoord(mapLat, mapLong)"
                                    style="border: 1px solid black">
                                </iframe>
                                <br />
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="mapDialog = false">Fermer</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-dialog v-model="addPoliticianDialog" persistent max-width="600px">
                <v-card>
                    <v-card-title class="primary">
                        <span class="headline" style="color: #fff;">Ajouter un compte twitter</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-flex xs12>
                                    <v-text-field v-model="addPoliticianForm.name" prepend-icon="fas fa-user"
                                        label="Nom" hint="Nom affiché sur le profil" required></v-text-field>
                                </v-flex>
                                <v-flex xs12>
                                    <v-text-field v-model="addPoliticianForm.twitter" prepend-icon="fab fa-twitter"
                                        label="Compte twitter"
                                        hint="Nom utilisé dans les mentions sur Twitter (sans le @)" required>
                                    </v-text-field>
                                </v-flex>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="red darken-1" flat @click="addPoliticianDialog = false">Fermer</v-btn>
                        <v-btn color="blue darken-1" flat @click="addPolitician()">Ajouter</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

            <v-footer class="pa-3 primary" style="color: #fff;" app>
                <v-fab-transition>
                    <v-tooltip top>
                        <v-btn color="white" dark absolute top left fab slot="activator" @click="openTwitter">
                            <v-icon style="color: #1da1f2;">fab fa-twitter</v-icon>
                        </v-btn>
                        <span>Aller sur Twitter</span>
                    </v-tooltip>
                </v-fab-transition>
                <v-spacer></v-spacer>
                <div>&copy; {{ new Date().getFullYear() }} - Quentin Mazoua</div>
                <v-spacer></v-spacer>
            </v-footer>

            <v-snackbar v-model="snackbar" :timeout="2500" top>
                {{ snackbarMessage }}
                <v-btn color="red" flat @click="snackbar = false">
                    Fermer
                </v-btn>
            </v-snackbar>
        </v-app>
    </div>

    <script type="module">
        import { Home } from './components/home.js';
        import { About } from './components/about.js';
        import { TweetsList } from './components/tweets-list.js';

        const routes = [
            { path: '/', component: Home },
            { path: '/about', component: About },
            { path: '/tweets', component: TweetsList, props: true },
        ];

        const router = new VueRouter({
            routes
        });

        const store = new Vuex.Store({
            state: {
                tweets: [],
                savedSubjects: []
            },
            getters: {
                tweets: state => state.tweets,
                savedSubjects: state => state.savedSubjects
            },
            mutations: {
                changeTweets(state, payload) {
                    state.tweets = payload.tweets;
                },
                changeSavedSubjects(state, payload) {
                    state.savedSubjects = payload.savedSubjects;
                }
            },
            actions: {
                changeTweetsAsync({ commit }, payload) {
                    setTimeout(() => {
                        commit('changeTweets', payload);
                    }, 1000)
                },
                changeSavedSubjectsAsync({ commit }, payload) {
                    setTimeout(() => {
                        commit('changeSavedSubjects', payload);
                    }, 1000)
                }
            }
        });

        const app = new Vue({
            router: router,
            store: store,
            data: {
                appMenu: null,
                menuItems: [
                    { title: 'Accueil', icon: 'dashboard', route: '/' },
                    { title: 'A propos', icon: 'question_answer', route: '/about' }
                ],
                twitterAccounts: [
                ],
                selectedAccount: '',
                query: '',
                loading: false,
                dialogLoading: false,
                loadingAccounts: false,
                searchSettings: { frOnly: true },
                globalSettings: { darkTheme: false },
                searchSettingsDialog: false,
                globalSettingsDialog: false,
                loginDialog: false,
                registerDialog: false,
                profileDialog: false,
                mapDialog: false,
                addPoliticianDialog: false,
                mapLat: null,
                mapLong: null,
                mapLoading: false,
                loginForm: { user: '', password: '' },
                registerForm: { name: '', user: '', password: '' },
                addPoliticianForm: { name: '', twitter: '' },
                user: null,
                savedSubjects: [],
                snackbar: false,
                snackbarMessage: ''
            },
            methods: {
                navTo: function (route, params) { this.$router.push({ path: route, params: params }); },
                openTwitter: function () { window.open('https://twitter.com') },
                search: function (query) {
                    this.loading = true;
                    this.setTweets([]);

                    if (this.selectedAccount) query += (' from:' + this.selectedAccount);

                    axios.get(`/search/` + query)
                        .then(response => {
                            var result = JSON.parse(response.data).statuses;

                            var tweets = result.map(tweet => {
                                return {
                                    id: tweet.id,
                                    createdAt: tweet.created_at,
                                    text: tweet.text,
                                    place: tweet.place,
                                    user: {
                                        id: tweet.user.id,
                                        name: tweet.user.name,
                                        profileImage: tweet.user.profile_image_url,
                                        location: tweet.user.location
                                    },
                                    favoriteCount: tweet.favorite_count,
                                    retweetCount: tweet.retweet_count
                                }
                            });

                            this.loading = false;

                            this.setTweets(tweets);

                            this.navTo('/tweets');
                        })
                        .catch(e => {
                            console.log(e);
                        })
                },
                login(user, password) {
                    this.dialogLoading = true;

                    axios.post(`/users/auth`, { user: { user: user, password: password } })
                        .then(response => {
                            this.user = response.data;
                            localStorage.setItem('user', JSON.stringify(this.user));
                            this.dialogLoading = false;
                            this.loginDialog = false;
                        })
                        .catch(e => { console.log(e); });
                },
                register(name, twitter_account, user, password) {
                    this.dialogLoading = true;

                    axios.post(`/users`, { user: { name: name, twitter_account: twitter_account, user: user, password: password } })
                        .then(response => {
                            this.dialogLoading = false;
                            this.registerDialog = false;
                        })
                        .catch(e => { console.log(e); });
                },
                logout() {
                    this.user = null;
                    localStorage.removeItem('user');
                },
                selectTwitterAccount(index) {
                    this.twitterAccounts[index].active = !this.twitterAccounts[index].active;

                    if (this.twitterAccounts[index].active) {
                        this.twitterAccounts.forEach((element, i) => {
                            if (i != index) element.active = false;
                        });

                        this.selectedAccount = this.twitterAccounts[index].twitterRef;
                    }
                    else {
                        this.selectedAccount = '';
                    }
                },
                showSavedTweets() {
                    axios.get(`/users/${this.user.user}/tweets`).then(resp => {
                        this.user.saved_tweets = resp.data;
                        this.setTweets(this.user.saved_tweets);
                        this.profileDialog = false;
                        this.navTo('/tweets');
                    }).catch(e => { console.log(e); })
                },
                setTweets(tweets) {
                    store.dispatch('changeTweetsAsync', {
                        tweets: tweets
                    });
                },
                setSavedSubjects(savedSubjects) {
                    this.savedSubjects = savedSubjects;
                    store.dispatch('changeSavedSubjectsAsync', {
                        savedSubjects: savedSubjects
                    });
                },
                getCoord() {
                    return (this.mapLat != null && this.mapLong != null) ? `&marker=${this.mapLat}%2C${this.mapLong}` : '';
                },
                getSavedSubjects() {
                    axios.get(`/users/${this.user.user}/subjects`).then(resp => {
                        this.setSavedSubjects(resp.data);
                    }).catch(e => { console.log(e); });
                },
                getSavedAccounts() {
                    this.loadingAccounts = true;
                    axios.get(`/users/${this.user.user}/accounts`).then(resp => {
                        this.twitterAccounts = resp.data;
                        this.loadingAccounts = false;
                    }).catch(e => { console.log(e); });
                },
                addPolitician() {
                    this.addPoliticianDialog = false;
                    this.loadingAccounts = true;
                    axios.post(`/users/${this.user.user}/accounts`, { account: this.addPoliticianForm }).then(resp => {
                        this.twitterAccounts.push(resp.data);
                        this.loadingAccounts = false;

                    }).catch(e => { console.log(e); this.loadingAccounts = false; });
                }
            },
            created() {
                if (localStorage.getItem('user')) this.user = JSON.parse(localStorage.getItem('user'));
                if (this.user) {
                    this.getSavedSubjects();
                    this.getSavedAccounts();
                }
            },
            mounted() {
                this.$root.$on('subject-picked', (subject) => {
                    this.search(subject);
                });
                this.$root.$on('add-subject-favorite', (subject) => {
                    if (this.user) {
                        axios.post(`/users/${this.user.user}/subjects`, { subject: subject }).then(response => {
                            this.savedSubjects.push(subject);
                            this.setSavedSubjects(this.savedSubjects);
                        });
                    }
                    else {
                        this.snackbar = true;
                        this.snackbarMessage = 'Vous devez être connecté';
                    }
                });
                this.$root.$on('save-tweet', (tweet) => {
                    axios.post(`/users/${this.user.user}/tweets`, { tweet: tweet }).then(response => {});
                });
                this.$root.$on('remove-subject-favorite', (subject) => {
                    this.savedSubjects.splice(subject.index, 1);
                    this.setSavedSubjects(this.savedSubjects);
                    axios.delete(`/users/${this.user.user}/subjects`, { data: { subject: subject.title } }).then(resp => {})
                    .catch(e => { console.log(e); });
                });
                this.$root.$on('show-map', (tweet) => {
                    this.mapDialog = true;
                    var location = tweet.place ? tweet.place : tweet.user.location;
                    this.mapLat = null;
                    this.mapLong = null;
                    if (location) {
                        this.mapLoading = true;
                        axios.get(`http://api.mapbox.com/geocoding/v5/mapbox.places/${location}.json?access_token=pk.eyJ1IjoicW1hem91YSIsImEiOiJjanRqcjMwcGEwb3Z2NDRuMDZ1YnR3Z2c1In0.uyHc4JqD9JPohdDyfEf8yQ`).then(resp => {
                            this.mapLoading = false;
                            if (resp.data.features[0]) {
                                if (resp.data.features[0].center) {
                                    this.mapLat = resp.data.features[0].center[1];
                                    this.mapLong = resp.data.features[0].center[0];
                                }
                            }
                        }).catch(e => { this.mapLoading = false; console.log(e) });
                    }
                });
            }
        }).$mount('#app');
    </script>
</body>

</html>